diff -ru openssh-3.7.1p1.orig/config.h.in openssh-3.7.1p1/config.h.in
--- openssh-3.7.1p1.orig/config.h.in	2003-09-17 07:38:13.000000000 +1000
+++ openssh-3.7.1p1/config.h.in	2003-09-18 09:38:40.000000000 +1000
@@ -1,4 +1,4 @@
-/* config.h.in.  Generated automatically from configure.ac by autoheader.  */
+/* config.h.in.  Generated from configure.ac by autoheader.  */
 /* $Id: acconfig.h,v 1.166 2003/09/16 01:52:19 dtucker Exp $ */
 
 /*
@@ -32,7 +32,6 @@
 /* Please make your changes there */
 
 
-
 /* Define if your platform breaks doing a seteuid before a setuid */
 #undef SETEUID_BREAKS_SETUID
 
@@ -60,6 +59,9 @@
 /* from environment and PATH */
 #undef LOGIN_PROGRAM_FALLBACK
 
+/* Path to passwd program */
+#undef PASSWD_PROGRAM_PATH
+
 /* Define if your password has a pw_class field */
 #undef HAVE_PW_CLASS_IN_PASSWD
 
@@ -426,534 +428,549 @@
 #undef HAVE_HEADER_AD
 
 
-/* Define if the `getpgrp' function takes no argument. */
+/* Define to 1 if the `getpgrp' function requires zero arguments. */
 #undef GETPGRP_VOID
 
-/* Define if you have the `arc4random' function. */
+/* Define to 1 if you have the `arc4random' function. */
 #undef HAVE_ARC4RANDOM
 
-/* Define if you have the `b64_ntop' function. */
+/* Define to 1 if you have the `b64_ntop' function. */
 #undef HAVE_B64_NTOP
 
-/* Define if you have the `b64_pton' function. */
+/* Define to 1 if you have the `b64_pton' function. */
 #undef HAVE_B64_PTON
 
-/* Define if you have the `basename' function. */
+/* Define to 1 if you have the `basename' function. */
 #undef HAVE_BASENAME
 
-/* Define if you have the `bcopy' function. */
+/* Define to 1 if you have the `bcopy' function. */
 #undef HAVE_BCOPY
 
-/* Define if you have the `bindresvport_sa' function. */
+/* Define to 1 if you have the `bindresvport_sa' function. */
 #undef HAVE_BINDRESVPORT_SA
 
-/* Define if you have the <bstring.h> header file. */
+/* Define to 1 if you have the <bstring.h> header file. */
 #undef HAVE_BSTRING_H
 
-/* Define if you have the `clock' function. */
+/* Define to 1 if you have the `clock' function. */
 #undef HAVE_CLOCK
 
-/* Define if you have the <crypt.h> header file. */
+/* Define to 1 if you have the <crypt.h> header file. */
 #undef HAVE_CRYPT_H
 
-/* Define if you have the `dirname' function. */
+/* Define to 1 if you have the `dirname' function. */
 #undef HAVE_DIRNAME
 
-/* Define if you have the <endian.h> header file. */
+/* Define to 1 if you have the <endian.h> header file. */
 #undef HAVE_ENDIAN_H
 
-/* Define if you have the `endutent' function. */
+/* Define to 1 if you have the `endutent' function. */
 #undef HAVE_ENDUTENT
 
-/* Define if you have the `endutxent' function. */
+/* Define to 1 if you have the `endutxent' function. */
 #undef HAVE_ENDUTXENT
 
-/* Define if you have the `fchmod' function. */
+/* Define to 1 if you have the `fchmod' function. */
 #undef HAVE_FCHMOD
 
-/* Define if you have the `fchown' function. */
+/* Define to 1 if you have the `fchown' function. */
 #undef HAVE_FCHOWN
 
-/* Define if you have the <features.h> header file. */
+/* Define to 1 if you have the <features.h> header file. */
 #undef HAVE_FEATURES_H
 
-/* Define if you have the <floatingpoint.h> header file. */
+/* Define to 1 if you have the <floatingpoint.h> header file. */
 #undef HAVE_FLOATINGPOINT_H
 
-/* Define if you have the `freeaddrinfo' function. */
+/* Define to 1 if you have the `freeaddrinfo' function. */
 #undef HAVE_FREEADDRINFO
 
-/* Define if you have the `futimes' function. */
+/* Define to 1 if you have the `futimes' function. */
 #undef HAVE_FUTIMES
 
-/* Define if you have the `gai_strerror' function. */
+/* Define to 1 if you have the `gai_strerror' function. */
 #undef HAVE_GAI_STRERROR
 
-/* Define if you have the `getaddrinfo' function. */
+/* Define to 1 if you have the `getaddrinfo' function. */
 #undef HAVE_GETADDRINFO
 
-/* Define if you have the `getcwd' function. */
+/* Define to 1 if you have the `getcwd' function. */
 #undef HAVE_GETCWD
 
-/* Define if you have the `getgrouplist' function. */
+/* Define to 1 if you have the `getgrouplist' function. */
 #undef HAVE_GETGROUPLIST
 
-/* Define if you have the `getluid' function. */
+/* Define to 1 if you have the `getluid' function. */
 #undef HAVE_GETLUID
 
-/* Define if you have the `getnameinfo' function. */
+/* Define to 1 if you have the `getnameinfo' function. */
 #undef HAVE_GETNAMEINFO
 
-/* Define if you have the `getopt' function. */
+/* Define to 1 if you have the `getopt' function. */
 #undef HAVE_GETOPT
 
-/* Define if you have the <getopt.h> header file. */
+/* Define to 1 if you have the <getopt.h> header file. */
 #undef HAVE_GETOPT_H
 
-/* Define if you have the `getpeereid' function. */
+/* Define to 1 if you have the `getpeereid' function. */
 #undef HAVE_GETPEEREID
 
-/* Define if you have the `getpwanam' function. */
+/* Define to 1 if you have the `getpwanam' function. */
 #undef HAVE_GETPWANAM
 
-/* Define if you have the `getrlimit' function. */
+/* Define to 1 if you have the `getrlimit' function. */
 #undef HAVE_GETRLIMIT
 
-/* Define if you have the `getrusage' function. */
+/* Define to 1 if you have the `getrusage' function. */
 #undef HAVE_GETRUSAGE
 
-/* Define if you have the `gettimeofday' function. */
+/* Define to 1 if you have the `gettimeofday' function. */
 #undef HAVE_GETTIMEOFDAY
 
-/* Define if you have the `getttyent' function. */
+/* Define to 1 if you have the `getttyent' function. */
 #undef HAVE_GETTTYENT
 
-/* Define if you have the `getutent' function. */
+/* Define to 1 if you have the `getutent' function. */
 #undef HAVE_GETUTENT
 
-/* Define if you have the `getutid' function. */
+/* Define to 1 if you have the `getutid' function. */
 #undef HAVE_GETUTID
 
-/* Define if you have the `getutline' function. */
+/* Define to 1 if you have the `getutline' function. */
 #undef HAVE_GETUTLINE
 
-/* Define if you have the `getutxent' function. */
+/* Define to 1 if you have the `getutxent' function. */
 #undef HAVE_GETUTXENT
 
-/* Define if you have the `getutxid' function. */
+/* Define to 1 if you have the `getutxid' function. */
 #undef HAVE_GETUTXID
 
-/* Define if you have the `getutxline' function. */
+/* Define to 1 if you have the `getutxline' function. */
 #undef HAVE_GETUTXLINE
 
-/* Define if you have the `glob' function. */
+/* Define to 1 if you have the `glob' function. */
 #undef HAVE_GLOB
 
-/* Define if you have the <glob.h> header file. */
+/* Define to 1 if you have the <glob.h> header file. */
 #undef HAVE_GLOB_H
 
-/* Define if you have the <gssapi.h> header file. */
+/* Define to 1 if you have the <gssapi.h> header file. */
 #undef HAVE_GSSAPI_H
 
-/* Define if you have the <ia.h> header file. */
+/* Define to 1 if you have the <ia.h> header file. */
 #undef HAVE_IA_H
 
-/* Define if you have the `inet_aton' function. */
+/* Define to 1 if you have the `inet_aton' function. */
 #undef HAVE_INET_ATON
 
-/* Define if you have the `inet_ntoa' function. */
+/* Define to 1 if you have the `inet_ntoa' function. */
 #undef HAVE_INET_NTOA
 
-/* Define if you have the `inet_ntop' function. */
+/* Define to 1 if you have the `inet_ntop' function. */
 #undef HAVE_INET_NTOP
 
-/* Define if you have the `innetgr' function. */
+/* Define to 1 if you have the `innetgr' function. */
 #undef HAVE_INNETGR
 
-/* Define if you have the <inttypes.h> header file. */
+/* Define to 1 if you have the <inttypes.h> header file. */
 #undef HAVE_INTTYPES_H
 
-/* Define if you have the <lastlog.h> header file. */
+/* Define to 1 if you have the <lastlog.h> header file. */
 #undef HAVE_LASTLOG_H
 
-/* Define if you have the `crypt' library (-lcrypt). */
+/* Define to 1 if you have the `crypt' library (-lcrypt). */
 #undef HAVE_LIBCRYPT
 
-/* Define if you have the `dl' library (-ldl). */
+/* Define to 1 if you have the `dl' library (-ldl). */
 #undef HAVE_LIBDL
 
-/* Define if you have the <libgen.h> header file. */
+/* Define to 1 if you have the <libgen.h> header file. */
 #undef HAVE_LIBGEN_H
 
-/* Define if you have the `nsl' library (-lnsl). */
+/* Define to 1 if you have the `nsl' library (-lnsl). */
 #undef HAVE_LIBNSL
 
-/* Define if you have the `pam' library (-lpam). */
+/* Define to 1 if you have the `pam' library (-lpam). */
 #undef HAVE_LIBPAM
 
-/* Define if you have the `sectok' library (-lsectok). */
+/* Define to 1 if you have the `sectok' library (-lsectok). */
 #undef HAVE_LIBSECTOK
 
-/* Define if you have the `socket' library (-lsocket). */
+/* Define to 1 if you have the `socket' library (-lsocket). */
 #undef HAVE_LIBSOCKET
 
-/* Define if you have the <libutil.h> header file. */
+/* Define to 1 if you have the <libutil.h> header file. */
 #undef HAVE_LIBUTIL_H
 
-/* Define if you have the `xnet' library (-lxnet). */
+/* Define to 1 if you have the `xnet' library (-lxnet). */
 #undef HAVE_LIBXNET
 
-/* Define if you have the `z' library (-lz). */
+/* Define to 1 if you have the `z' library (-lz). */
 #undef HAVE_LIBZ
 
-/* Define if you have the <limits.h> header file. */
+/* Define to 1 if you have the <limits.h> header file. */
 #undef HAVE_LIMITS_H
 
-/* Define if you have the <login_cap.h> header file. */
+/* Define to 1 if you have the <login_cap.h> header file. */
 #undef HAVE_LOGIN_CAP_H
 
-/* Define if you have the `login_getcapbool' function. */
+/* Define to 1 if you have the `login_getcapbool' function. */
 #undef HAVE_LOGIN_GETCAPBOOL
 
-/* Define if you have the <login.h> header file. */
+/* Define to 1 if you have the <login.h> header file. */
 #undef HAVE_LOGIN_H
 
-/* Define if you have the `logout' function. */
+/* Define to 1 if you have the `logout' function. */
 #undef HAVE_LOGOUT
 
-/* Define if you have the `logwtmp' function. */
+/* Define to 1 if you have the `logwtmp' function. */
 #undef HAVE_LOGWTMP
 
-/* Define if you have the <maillock.h> header file. */
+/* Define to 1 if you have the <maillock.h> header file. */
 #undef HAVE_MAILLOCK_H
 
-/* Define if you have the `md5_crypt' function. */
+/* Define to 1 if you have the `md5_crypt' function. */
 #undef HAVE_MD5_CRYPT
 
-/* Define if you have the `memmove' function. */
+/* Define to 1 if you have the `memmove' function. */
 #undef HAVE_MEMMOVE
 
-/* Define if you have the <memory.h> header file. */
+/* Define to 1 if you have the <memory.h> header file. */
 #undef HAVE_MEMORY_H
 
-/* Define if you have the `mkdtemp' function. */
+/* Define to 1 if you have the `mkdtemp' function. */
 #undef HAVE_MKDTEMP
 
-/* Define if you have the `mmap' function. */
+/* Define to 1 if you have the `mmap' function. */
 #undef HAVE_MMAP
 
-/* Define if you have the <netdb.h> header file. */
+/* Define to 1 if you have the <netdb.h> header file. */
 #undef HAVE_NETDB_H
 
-/* Define if you have the <netgroup.h> header file. */
+/* Define to 1 if you have the <netgroup.h> header file. */
 #undef HAVE_NETGROUP_H
 
-/* Define if you have the <netinet/in_systm.h> header file. */
+/* Define to 1 if you have the <netinet/in_systm.h> header file. */
 #undef HAVE_NETINET_IN_SYSTM_H
 
-/* Define if you have the `ngetaddrinfo' function. */
+/* Define to 1 if you have the `ngetaddrinfo' function. */
 #undef HAVE_NGETADDRINFO
 
-/* Define if you have the `nsleep' function. */
+/* Define to 1 if you have the `nsleep' function. */
 #undef HAVE_NSLEEP
 
-/* Define if you have the `ogetaddrinfo' function. */
+/* Define to 1 if you have the `ogetaddrinfo' function. */
 #undef HAVE_OGETADDRINFO
 
-/* Define if you have the `openlog_r' function. */
+/* Define to 1 if you have the `openlog_r' function. */
 #undef HAVE_OPENLOG_R
 
-/* Define if you have the `openpty' function. */
+/* Define to 1 if you have the `openpty' function. */
 #undef HAVE_OPENPTY
 
-/* Define if you have the `pam_getenvlist' function. */
+/* Define to 1 if you have the `pam_getenvlist' function. */
 #undef HAVE_PAM_GETENVLIST
 
-/* Define if you have the `pam_putenv' function. */
+/* Define to 1 if you have the `pam_putenv' function. */
 #undef HAVE_PAM_PUTENV
 
-/* Define if you have the <paths.h> header file. */
+/* Define to 1 if you have the <paths.h> header file. */
 #undef HAVE_PATHS_H
 
-/* Define if you have the `pstat' function. */
+/* Define to 1 if you have the `pstat' function. */
 #undef HAVE_PSTAT
 
-/* Define if you have the <pty.h> header file. */
+/* Define to 1 if you have the <pty.h> header file. */
 #undef HAVE_PTY_H
 
-/* Define if you have the `pututline' function. */
+/* Define to 1 if you have the `pututline' function. */
 #undef HAVE_PUTUTLINE
 
-/* Define if you have the `pututxline' function. */
+/* Define to 1 if you have the `pututxline' function. */
 #undef HAVE_PUTUTXLINE
 
-/* Define if you have the `readpassphrase' function. */
+/* Define to 1 if you have the `readpassphrase' function. */
 #undef HAVE_READPASSPHRASE
 
-/* Define if you have the <readpassphrase.h> header file. */
+/* Define to 1 if you have the <readpassphrase.h> header file. */
 #undef HAVE_READPASSPHRASE_H
 
-/* Define if you have the `realpath' function. */
+/* Define to 1 if you have the `realpath' function. */
 #undef HAVE_REALPATH
 
-/* Define if you have the `recvmsg' function. */
+/* Define to 1 if you have the `recvmsg' function. */
 #undef HAVE_RECVMSG
 
-/* Define if you have the <rpc/types.h> header file. */
+/* Define to 1 if you have the <rpc/types.h> header file. */
 #undef HAVE_RPC_TYPES_H
 
-/* Define if you have the `rresvport_af' function. */
+/* Define to 1 if you have the `rresvport_af' function. */
 #undef HAVE_RRESVPORT_AF
 
-/* Define if you have the <sectok.h> header file. */
+/* Define to 1 if you have the <sectok.h> header file. */
 #undef HAVE_SECTOK_H
 
-/* Define if you have the <security/pam_appl.h> header file. */
+/* Define to 1 if you have the <security/pam_appl.h> header file. */
 #undef HAVE_SECURITY_PAM_APPL_H
 
-/* Define if you have the `sendmsg' function. */
+/* Define to 1 if you have the `sendmsg' function. */
 #undef HAVE_SENDMSG
 
-/* Define if you have the `setauthdb' function. */
+/* Define to 1 if you have the `setauthdb' function. */
 #undef HAVE_SETAUTHDB
 
-/* Define if you have the `setdtablesize' function. */
+/* Define to 1 if you have the `setdtablesize' function. */
 #undef HAVE_SETDTABLESIZE
 
-/* Define if you have the `setegid' function. */
+/* Define to 1 if you have the `setegid' function. */
 #undef HAVE_SETEGID
 
-/* Define if you have the `setenv' function. */
+/* Define to 1 if you have the `setenv' function. */
 #undef HAVE_SETENV
 
-/* Define if you have the `seteuid' function. */
+/* Define to 1 if you have the `seteuid' function. */
 #undef HAVE_SETEUID
 
-/* Define if you have the `setgroups' function. */
+/* Define to 1 if you have the `setgroups' function. */
 #undef HAVE_SETGROUPS
 
-/* Define if you have the `setlogin' function. */
+/* Define to 1 if you have the `setlogin' function. */
 #undef HAVE_SETLOGIN
 
-/* Define if you have the `setluid' function. */
+/* Define to 1 if you have the `setluid' function. */
 #undef HAVE_SETLUID
 
-/* Define if you have the `setpcred' function. */
+/* Define to 1 if you have the `setpcred' function. */
 #undef HAVE_SETPCRED
 
-/* Define if you have the `setproctitle' function. */
+/* Define to 1 if you have the `setproctitle' function. */
 #undef HAVE_SETPROCTITLE
 
-/* Define if you have the `setregid' function. */
+/* Define to 1 if you have the `setregid' function. */
 #undef HAVE_SETREGID
 
-/* Define if you have the `setresgid' function. */
+/* Define to 1 if you have the `setresgid' function. */
 #undef HAVE_SETRESGID
 
-/* Define if you have the `setresuid' function. */
+/* Define to 1 if you have the `setresuid' function. */
 #undef HAVE_SETRESUID
 
-/* Define if you have the `setreuid' function. */
+/* Define to 1 if you have the `setreuid' function. */
 #undef HAVE_SETREUID
 
-/* Define if you have the `setrlimit' function. */
+/* Define to 1 if you have the `setrlimit' function. */
 #undef HAVE_SETRLIMIT
 
-/* Define if you have the `setsid' function. */
+/* Define to 1 if you have the `setsid' function. */
 #undef HAVE_SETSID
 
-/* Define if you have the `setutent' function. */
+/* Define to 1 if you have the `setutent' function. */
 #undef HAVE_SETUTENT
 
-/* Define if you have the `setutxent' function. */
+/* Define to 1 if you have the `setutxent' function. */
 #undef HAVE_SETUTXENT
 
-/* Define if you have the `setvbuf' function. */
+/* Define to 1 if you have the `setvbuf' function. */
 #undef HAVE_SETVBUF
 
-/* Define if you have the <shadow.h> header file. */
+/* Define to 1 if you have the <shadow.h> header file. */
 #undef HAVE_SHADOW_H
 
-/* Define if you have the `sigaction' function. */
+/* Define to 1 if you have the `sigaction' function. */
 #undef HAVE_SIGACTION
 
-/* Define if you have the `sigvec' function. */
+/* Define to 1 if you have the `sigvec' function. */
 #undef HAVE_SIGVEC
 
-/* Define if the system has the type `sig_atomic_t'. */
+/* Define to 1 if the system has the type `sig_atomic_t'. */
 #undef HAVE_SIG_ATOMIC_T
 
-/* Define if you have the `snprintf' function. */
+/* Define to 1 if you have the `snprintf' function. */
 #undef HAVE_SNPRINTF
 
-/* Define if you have the `socketpair' function. */
+/* Define to 1 if you have the `socketpair' function. */
 #undef HAVE_SOCKETPAIR
 
-/* Define if you have the <stddef.h> header file. */
+/* Define to 1 if you have the <stddef.h> header file. */
 #undef HAVE_STDDEF_H
 
-/* Define if you have the <stdint.h> header file. */
+/* Define to 1 if you have the <stdint.h> header file. */
 #undef HAVE_STDINT_H
 
-/* Define if you have the <stdlib.h> header file. */
+/* Define to 1 if you have the <stdlib.h> header file. */
 #undef HAVE_STDLIB_H
 
-/* Define if you have the `strerror' function. */
+/* Define to 1 if you have the `strerror' function. */
 #undef HAVE_STRERROR
 
-/* Define if you have the `strftime' function. */
+/* Define to 1 if you have the `strftime' function. */
 #undef HAVE_STRFTIME
 
-/* Define if you have the <strings.h> header file. */
+/* Define to 1 if you have the <strings.h> header file. */
 #undef HAVE_STRINGS_H
 
-/* Define if you have the <string.h> header file. */
+/* Define to 1 if you have the <string.h> header file. */
 #undef HAVE_STRING_H
 
-/* Define if you have the `strlcat' function. */
+/* Define to 1 if you have the `strlcat' function. */
 #undef HAVE_STRLCAT
 
-/* Define if you have the `strlcpy' function. */
+/* Define to 1 if you have the `strlcpy' function. */
 #undef HAVE_STRLCPY
 
-/* Define if you have the `strmode' function. */
+/* Define to 1 if you have the `strmode' function. */
 #undef HAVE_STRMODE
 
-/* Define if you have the `strnvis' function. */
+/* Define to 1 if you have the `strnvis' function. */
 #undef HAVE_STRNVIS
 
-/* Define if you have the `strsep' function. */
+/* Define to 1 if you have the `strsep' function. */
 #undef HAVE_STRSEP
 
-/* Define if `st_blksize' is member of `struct stat'. */
+/* Define to 1 if `st_blksize' is member of `struct stat'. */
 #undef HAVE_STRUCT_STAT_ST_BLKSIZE
 
-/* Define if the system has the type `struct timespec'. */
+/* Define to 1 if the system has the type `struct timespec'. */
 #undef HAVE_STRUCT_TIMESPEC
 
-/* Define if you have the `sysconf' function. */
+/* Define to 1 if you have the `sysconf' function. */
 #undef HAVE_SYSCONF
 
-/* Define if you have the <sys/audit.h> header file. */
+/* Define to 1 if you have the <sys/audit.h> header file. */
 #undef HAVE_SYS_AUDIT_H
 
-/* Define if you have the <sys/bitypes.h> header file. */
+/* Define to 1 if you have the <sys/bitypes.h> header file. */
 #undef HAVE_SYS_BITYPES_H
 
-/* Define if you have the <sys/bsdtty.h> header file. */
+/* Define to 1 if you have the <sys/bsdtty.h> header file. */
 #undef HAVE_SYS_BSDTTY_H
 
-/* Define if you have the <sys/cdefs.h> header file. */
+/* Define to 1 if you have the <sys/cdefs.h> header file. */
 #undef HAVE_SYS_CDEFS_H
 
-/* Define if you have the <sys/mman.h> header file. */
+/* Define to 1 if you have the <sys/mman.h> header file. */
 #undef HAVE_SYS_MMAN_H
 
-/* Define if you have the <sys/pstat.h> header file. */
+/* Define to 1 if you have the <sys/pstat.h> header file. */
 #undef HAVE_SYS_PSTAT_H
 
-/* Define if you have the <sys/select.h> header file. */
+/* Define to 1 if you have the <sys/select.h> header file. */
 #undef HAVE_SYS_SELECT_H
 
-/* Define if you have the <sys/stat.h> header file. */
+/* Define to 1 if you have the <sys/stat.h> header file. */
 #undef HAVE_SYS_STAT_H
 
-/* Define if you have the <sys/stropts.h> header file. */
+/* Define to 1 if you have the <sys/stropts.h> header file. */
 #undef HAVE_SYS_STROPTS_H
 
-/* Define if you have the <sys/strtio.h> header file. */
+/* Define to 1 if you have the <sys/strtio.h> header file. */
 #undef HAVE_SYS_STRTIO_H
 
-/* Define if you have the <sys/sysmacros.h> header file. */
+/* Define to 1 if you have the <sys/sysmacros.h> header file. */
 #undef HAVE_SYS_SYSMACROS_H
 
-/* Define if you have the <sys/timers.h> header file. */
+/* Define to 1 if you have the <sys/timers.h> header file. */
 #undef HAVE_SYS_TIMERS_H
 
-/* Define if you have the <sys/time.h> header file. */
+/* Define to 1 if you have the <sys/time.h> header file. */
 #undef HAVE_SYS_TIME_H
 
-/* Define if you have the <sys/types.h> header file. */
+/* Define to 1 if you have the <sys/types.h> header file. */
 #undef HAVE_SYS_TYPES_H
 
-/* Define if you have the <sys/un.h> header file. */
+/* Define to 1 if you have the <sys/un.h> header file. */
 #undef HAVE_SYS_UN_H
 
-/* Define if you have the `tcgetpgrp' function. */
+/* Define to 1 if you have the `tcgetpgrp' function. */
 #undef HAVE_TCGETPGRP
 
-/* Define if you have the `tcsendbreak' function. */
+/* Define to 1 if you have the `tcsendbreak' function. */
 #undef HAVE_TCSENDBREAK
 
-/* Define if you have the `time' function. */
+/* Define to 1 if you have the `time' function. */
 #undef HAVE_TIME
 
-/* Define if you have the <time.h> header file. */
+/* Define to 1 if you have the <time.h> header file. */
 #undef HAVE_TIME_H
 
-/* Define if you have the <tmpdir.h> header file. */
+/* Define to 1 if you have the <tmpdir.h> header file. */
 #undef HAVE_TMPDIR_H
 
-/* Define if you have the `truncate' function. */
+/* Define to 1 if you have the `truncate' function. */
 #undef HAVE_TRUNCATE
 
-/* Define if you have the <ttyent.h> header file. */
+/* Define to 1 if you have the <ttyent.h> header file. */
 #undef HAVE_TTYENT_H
 
-/* Define if you have the <unistd.h> header file. */
+/* Define to 1 if you have the <unistd.h> header file. */
 #undef HAVE_UNISTD_H
 
-/* Define if you have the `updwtmp' function. */
+/* Define to 1 if you have the `updwtmp' function. */
 #undef HAVE_UPDWTMP
 
-/* Define if you have the <usersec.h> header file. */
+/* Define to 1 if you have the <usersec.h> header file. */
 #undef HAVE_USERSEC_H
 
-/* Define if you have the <util.h> header file. */
+/* Define to 1 if you have the <util.h> header file. */
 #undef HAVE_UTIL_H
 
-/* Define if you have the `utimes' function. */
+/* Define to 1 if you have the `utimes' function. */
 #undef HAVE_UTIMES
 
-/* Define if you have the <utime.h> header file. */
+/* Define to 1 if you have the <utime.h> header file. */
 #undef HAVE_UTIME_H
 
-/* Define if you have the `utmpname' function. */
+/* Define to 1 if you have the `utmpname' function. */
 #undef HAVE_UTMPNAME
 
-/* Define if you have the `utmpxname' function. */
+/* Define to 1 if you have the `utmpxname' function. */
 #undef HAVE_UTMPXNAME
 
-/* Define if you have the <utmpx.h> header file. */
+/* Define to 1 if you have the <utmpx.h> header file. */
 #undef HAVE_UTMPX_H
 
-/* Define if you have the <utmp.h> header file. */
+/* Define to 1 if you have the <utmp.h> header file. */
 #undef HAVE_UTMP_H
 
-/* Define if you have the `vhangup' function. */
+/* Define to 1 if you have the `vhangup' function. */
 #undef HAVE_VHANGUP
 
-/* Define if you have the `vsnprintf' function. */
+/* Define to 1 if you have the `vsnprintf' function. */
 #undef HAVE_VSNPRINTF
 
-/* Define if you have the `waitpid' function. */
+/* Define to 1 if you have the `waitpid' function. */
 #undef HAVE_WAITPID
 
-/* Define if you have the `_getlong' function. */
+/* Define to 1 if you have the `_getlong' function. */
 #undef HAVE__GETLONG
 
-/* Define if you have the `_getpty' function. */
+/* Define to 1 if you have the `_getpty' function. */
 #undef HAVE__GETPTY
 
-/* Define if you have the `_getshort' function. */
+/* Define to 1 if you have the `_getshort' function. */
 #undef HAVE__GETSHORT
 
-/* Define if you have the `__b64_ntop' function. */
+/* Define to 1 if you have the `__b64_ntop' function. */
 #undef HAVE___B64_NTOP
 
-/* Define if you have the `__b64_pton' function. */
+/* Define to 1 if you have the `__b64_pton' function. */
 #undef HAVE___B64_PTON
 
+/* Define to the address where bug reports for this package should be sent. */
+#undef PACKAGE_BUGREPORT
+
+/* Define to the full name of this package. */
+#undef PACKAGE_NAME
+
+/* Define to the full name and version of this package. */
+#undef PACKAGE_STRING
+
+/* Define to the one symbol short name of this package. */
+#undef PACKAGE_TARNAME
+
+/* Define to the version of this package. */
+#undef PACKAGE_VERSION
+
 /* The size of a `char', as computed by sizeof. */
 #undef SIZEOF_CHAR
 
@@ -969,11 +986,11 @@
 /* The size of a `short int', as computed by sizeof. */
 #undef SIZEOF_SHORT_INT
 
-/* Define if you have the ANSI C header files. */
+/* Define to 1 if you have the ANSI C header files. */
 #undef STDC_HEADERS
 
-/* Define if your processor stores words with the most significant byte first
-   (like Motorola and SPARC, unlike Intel and VAX). */
+/* Define to 1 if your processor stores words with the most significant byte
+   first (like Motorola and SPARC, unlike Intel and VAX). */
 #undef WORDS_BIGENDIAN
 
 /* Number of bits in a file offset, on hosts where this is settable. */
diff -ru openssh-3.7.1p1.orig/configure.ac openssh-3.7.1p1/configure.ac
--- openssh-3.7.1p1.orig/configure.ac	2003-09-16 15:48:15.000000000 +1000
+++ openssh-3.7.1p1/configure.ac	2003-09-18 09:38:40.000000000 +1000
@@ -42,6 +42,13 @@
 	fi
 fi
 
+AC_PATH_PROG(PASSWD_PROGRAM_PATH, passwd)
+if test ! -z "$PASSWD_PROGRAM_PATH" ; then
+	AC_DEFINE_UNQUOTED(PASSWD_PROGRAM_PATH, "$PASSWD_PROGRAM_PATH")
+else
+	AC_MSG_ERROR([*** passwd command not found - check config.log ***])
+fi
+
 if test -z "$LD" ; then
 	LD=$CC
 fi
diff -ru openssh-3.7.1p1.orig/scp.0 openssh-3.7.1p1/scp.0
--- openssh-3.7.1p1.orig/scp.0	2003-09-17 07:38:36.000000000 +1000
+++ openssh-3.7.1p1/scp.0	2003-09-18 09:40:07.000000000 +1000
@@ -1,4 +1,4 @@
-SCP(1)                     OpenBSD Reference Manual                     SCP(1)
+SCP(1)                  System General Commands Manual                  SCP(1)
 
 NAME
      scp - secure copy (remote file copy program)
@@ -41,8 +41,8 @@
              about their progress.  This is helpful in debugging connection,
              authentication, and configuration problems.
 
-     -B      Selects batch mode (prevents asking for passwords or passphras-
-             es).
+     -B      Selects batch mode (prevents asking for passwords or
+             passphrases).
 
      -q      Disables the progress meter.
 
@@ -91,4 +91,4 @@
      Timo Rinne <tri@iki.fi> and
      Tatu Ylonen <ylo@cs.hut.fi>
 
-OpenBSD 3.4                   September 25, 1999                             2
+BSD                           September 25, 1999                           BSD
diff -ru openssh-3.7.1p1.orig/servconf.c openssh-3.7.1p1/servconf.c
--- openssh-3.7.1p1.orig/servconf.c	2003-09-02 22:58:22.000000000 +1000
+++ openssh-3.7.1p1/servconf.c	2003-09-18 09:38:40.000000000 +1000
@@ -109,8 +109,13 @@
 fill_default_server_options(ServerOptions *options)
 {
 	/* Portable-specific options */
-	if (options->use_pam == -1)
+	if (options->use_pam == -1) {
+#ifdef USE_PAM
 		options->use_pam = 1;
+#else
+		options->use_pam = 0;
+#endif
+	}
 
 	/* Standard Options */
 	if (options->protocol == SSH_PROTO_UNKNOWN)
diff -ru openssh-3.7.1p1.orig/session.c openssh-3.7.1p1/session.c
--- openssh-3.7.1p1.orig/session.c	2003-09-16 11:52:19.000000000 +1000
+++ openssh-3.7.1p1/session.c	2003-09-18 09:38:40.000000000 +1000
@@ -94,6 +94,9 @@
 extern int startup_pipe;
 extern void destroy_sensitive_data(void);
 extern Buffer loginmsg;
+extern Buffer expiremsg;
+extern int password_change_required;
+
 
 /* original command from peer. */
 const char *original_command = NULL;
@@ -395,13 +398,12 @@
 	session_proctitle(s);
 
 #if defined(USE_PAM)
-	if (options.use_pam) {
+	if (options.use_pam)
 		do_pam_setcred(1);
-		if (is_pam_password_change_required())
-			packet_disconnect("Password change required but no "
-			    "TTY available");
-	}
 #endif /* USE_PAM */
+	if (password_change_required)
+		packet_disconnect("Password change required but no "
+		    "TTY available");
 
 	/* Fork the child. */
 	if ((pid = fork()) == 0) {
@@ -671,10 +673,10 @@
 void
 do_login(Session *s, const char *command)
 {
-	char *time_string;
 	socklen_t fromlen;
 	struct sockaddr_storage from;
 	struct passwd * pw = s->pw;
+	int password_changed = 0;
 	pid_t pid = getpid();
 
 	/*
@@ -698,25 +700,41 @@
 		    options.use_dns),
 		    (struct sockaddr *)&from, fromlen);
 
-#ifdef USE_PAM
 	/*
 	 * If password change is needed, do it now.
 	 * This needs to occur before the ~/.hushlogin check.
 	 */
-	if (options.use_pam && is_pam_password_change_required()) {
-		print_pam_messages();
-		do_pam_chauthtok();
+	buffer_append(&expiremsg, "\0", 1);
+	if (password_change_required) {
+		if (options.use_pam) {
+#ifdef USE_PAM
+			print_pam_messages();
+			if (use_privsep)
+				do_tty_change_password(pw);
+			else
+				do_pam_chauthtok();
+#endif
+		} else {
+			printf("%s", (char *)buffer_ptr(&expiremsg)),
+			fflush(stdout);
+			do_tty_change_password(pw);
+		}
+		password_changed = 1;	/* chauthtok will abort on failure */
 		/* XXX - signal [net] parent to enable forwardings */
 	}
-#endif
 
 	if (check_quietlogin(s, command))
 		return;
 
+	if (!password_changed) {
+		if (options.use_pam) {
 #ifdef USE_PAM
-	if (options.use_pam && !is_pam_password_change_required())
-		print_pam_messages();
-#endif /* USE_PAM */
+			print_pam_messages();
+#endif
+		} else {
+			printf("%s", (char *)buffer_ptr(&expiremsg));
+		}
+	}
 
 	/* display post-login message */
 	if (buffer_len(&loginmsg) > 0) {
@@ -725,19 +743,6 @@
 	}
 	buffer_free(&loginmsg);
 
-#ifndef NO_SSH_LASTLOG
-	if (options.print_lastlog && s->last_login_time != 0) {
-		time_string = ctime(&s->last_login_time);
-		if (strchr(time_string, '\n'))
-			*strchr(time_string, '\n') = 0;
-		if (strcmp(s->hostname, "") == 0)
-			printf("Last login: %s\r\n", time_string);
-		else
-			printf("Last login: %s from %s\r\n", time_string,
-			    s->hostname);
-	}
-#endif /* NO_SSH_LASTLOG */
-
 	do_motd();
 }
 
@@ -1617,12 +1622,6 @@
 		packet_disconnect("Protocol error: you already have a pty.");
 		return 0;
 	}
-	/* Get the time and hostname when the user last logged in. */
-	if (options.print_lastlog) {
-		s->hostname[0] = '\0';
-		s->last_login_time = get_last_login_time(s->pw->pw_uid,
-		    s->pw->pw_name, s->hostname, sizeof(s->hostname));
-	}
 
 	s->term = packet_get_string(&len);
 
diff -ru openssh-3.7.1p1.orig/session.h openssh-3.7.1p1/session.h
--- openssh-3.7.1p1.orig/session.h	2003-08-26 11:49:56.000000000 +1000
+++ openssh-3.7.1p1/session.h	2003-09-18 09:38:40.000000000 +1000
@@ -39,9 +39,6 @@
 	int	ptyfd, ttyfd, ptymaster;
 	u_int	row, col, xpixel, ypixel;
 	char	tty[TTYSZ];
-	/* last login */
-	char	hostname[MAXHOSTNAMELEN];
-	time_t	last_login_time;
 	/* X11 */
 	u_int	display_number;
 	char	*display;
